package XMLTest;

import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;   
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;
 
import org.xml.sax.SAXException;    

import java.io.File;
import java.io.IOException;

import org.w3c.dom.Document;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

public class Echo01DOM{
	static final String SCHEMA_LANGUAGE = "http://java.sun.com/xml/jaxp/properties/schemaLanguage";
	static final String W3C_XML_SCHEMA =  "http://www.w3.org/2001/XMLSchema"; 
	
    // Global value so it can be ref'd by the tree-adapter
    static Document document; 

    public static void main(String argv[])
    {
        if (argv.length != 1) {
            System.err.println("Usage: java Echo01DOM filename");
            System.exit(1);
        }

        //VALIDATION
//        System.out.println("VALIDATING ...");
//        try {
//			validityCheck(argv[0]);
//		} catch (SAXException e) {
//			e.printStackTrace();
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
        
		//PARSING
		System.out.println("PARSING ...");
        DocumentBuilderFactory factory =
            DocumentBuilderFactory.newInstance();
//        factory.setValidating(true);   
//        factory.setNamespaceAware(true);
//        factory.setAttribute(JAXP_SCHEMA_LANGUAGE, W3C_XML_SCHEMA);
        try {
           DocumentBuilder builder = factory.newDocumentBuilder();
           document = builder.parse( new File(argv[0]) );
           
           // use output format for pretty printing
           OutputFormat of = new OutputFormat("XML","ISO-8859-2",true);
           XMLSerializer serializer = new XMLSerializer(System.out, of);
           serializer.serialize( document.getDocumentElement() );
 
        } catch (SAXException sxe) {
           // Error generated during parsing)
           Exception  x = sxe;
           if (sxe.getException() != null)
               x = sxe.getException();
           x.printStackTrace();

        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            pce.printStackTrace();

        } catch (IOException ioe) {
           // I/O error
           ioe.printStackTrace();
        }
    } // main
    
    public static void validityCheck(String file) throws SAXException, IOException {

        // 1. Lookup a factory for the W3C XML Schema language
        SchemaFactory factory = 
            SchemaFactory.newInstance("http://www.w3.org/2001/XMLSchema");
        
        // 2. Compile the schema. 
        // Here the schema is loaded from a java.io.File, but you could use 
        // a java.net.URL or a javax.xml.transform.Source instead.
        Schema schema = null;
        //File schemaLocation = new File("/opt/xml/docbook/xsd/docbook.xsd");
        //schema = factory.newSchema(schemaLocation);
        schema = factory.newSchema();	// we will use a schema provided in XML file
    
        // 3. Get a validator from the schema.
        Validator validator = schema.newValidator();
        
        // 4. Parse the document you want to check.
        Source source = new StreamSource(file);
        
        // 5. Check the document
        try {
            validator.validate(source);
            System.out.println(file + " is valid.");
        }
        catch (SAXException ex) {
            System.out.println(file + " is not valid because ");
            System.out.println(ex.getMessage());
        }  
        
        // more examples - http://www.ibm.com/developerworks/xml/library/x-javaxmlvalidapi.html
    }


}
